package com.ibm.ccd.ui.cache;

import java.util.Set;

/**
 * Created on Jun 13, 2006
 */
public class CacheManager {
	
	//static variables
	private static CacheManager cacheManager;
	
	//Instance variables
	private CacheRegistry cacheRegistry = null;
	
	//Constructor
	private CacheManager() {
		
		cacheRegistry = CacheRegistry.getInstance();
		/*try{
			cacheRegistry.putValue("Group1","Key11","val11");
			cacheRegistry.putValue("Group1","Key12","val12");
			cacheRegistry.putValue("Group2","Key21","val21");
		}catch(Exception e){
			
		}*/
	}
	
	/*
	 * Method to get an instance of CacheManager
	 */
	public static CacheManager getInstance() {
		
		if(cacheManager == null)
			cacheManager = new CacheManager();
		
		return cacheManager;
	}
	
	/*
	 * Method to put a value in to cache
	 */
	public void putInCache(String groupId, String key, Object value) throws CacheException{
		
		this.cacheRegistry.putValue(groupId, key, value);
	}
	
	/*
	 * Method to get a value from cache
	 */
	public Object getFromCache(String groupId, String key)  throws CacheException {
		
		return this.cacheRegistry.getValue(groupId,key);
	}
	
	/*
	 * Method to reset a particular group
	 */
	public void resetCacheValue(String groupId, String key) throws CacheException {
		
		this.cacheRegistry.removeCacheKey(groupId,key);
	}

	public void resetGroup(String groupId) throws CacheException {
		
		this.cacheRegistry.resetGroup(groupId);
	}

	/*
	 * Method to reset cacheRegistry
	 */
	public void resetCacheRegistry() throws CacheException{
		this.cacheRegistry.resetCacheRegistry();
	}
	
	public boolean isCached(String groupId, String key){
		Object obj = null;
		try{
		   obj = this.cacheRegistry.getValue(groupId,key);
		} catch(CacheException e){
			
		}
		if(obj == null)
			return false;
		else 
			return true;
	}
	
	public Set getCacheGroups(){
		
		return this.cacheRegistry.getCacheGroups();
	}
	
	public Set getCacheKeys(String groupId){
		
		return this.cacheRegistry.getCacheKeys(groupId);
	}
}
