package com.ibm.ccd.ui.cache;

import java.util.HashMap;
import java.util.Set;

/**
 * Created on Jun 13, 2006
 * 
 * This object creates a cache and stores a key-value map for 
 * objects , which fall under a particular classification.
 */
public class SimpleCacheService {
	
	private HashMap cacheMap;
	
	protected SimpleCacheService() {
		
		//Initialize the cacheMap
		this.cacheMap = new HashMap(10);
	}
	
	/*
	 * Method to retieve a cache value
	 */
	public Object getCacheValue(String key) throws CacheException {
		
		if(cacheMap == null)
			throw new CacheException("Cache not initialized");
		
		if(!cacheMap.containsKey(key))
			throw new CacheException("No cache available for selected key");
		else 			
			return this.cacheMap.get(key);
	}
	
	/*
	 * Method to store a cache value
	 */
	public void putCacheValue(String key, Object value) throws CacheException {
		
		if(this.cacheMap == null)
			throw new CacheException("Cache not initialized");
		
		this.cacheMap.put(key,value);
	}
	
	/*
	 * To reset a simple cache service
	 */
	public void resetCache(){
		
		if(this.cacheMap != null)
			this.cacheMap = new HashMap();
	}
	
	
	public Set getCacheKeys() {
		
		return this.cacheMap.keySet();
	}
	
	public void removeKey(String key) throws CacheException{
		
		this.cacheMap.remove(key);
	}
}
