
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import java.net.URL;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.ImageURLAttribute;


public class ImageURLElement extends URLElement {
    public ImageURLElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @see com.ibm.ccd.wpc.tags.BaseElement#renderElement()
     */
    public String renderElement() {
        StringBuffer buffer = new StringBuffer();

        if (attribute.isMultiValued()) {
            for (int i = 0; i < attribute.getCurrOccurrence(); i++) {
                buffer.append(displayLabel());
                buffer.append(displayField(i, getStringValue(attribute, i)));
            }
        } else {
            buffer.append(displayLabel());
            buffer.append(displayField(0, getStringValue(attribute, 0)));
        }

        return buffer.toString();
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        ImageURLAttribute imgURLAttrib = (ImageURLAttribute) attribute;

        if (imgURLAttrib.getCurrentOccurrence() > 0) {
            if (imgURLAttrib.isMultiValued()) {
                URL[] urls = imgURLAttrib.getValues();

                return (urls[index] != null) ? urls[index].toString() : "";
            } else {
                return (imgURLAttrib.getValue() != null)
                ? imgURLAttrib.getValue().toString() : "";
            }
        } else {
            return "";
        }
    }
}
